﻿/* TODO list *****
 + make system idle delay the breaks (assumption is that they are not working when computer is idle)
 + have notification pop-ups instead of alerts
 + take break now button that appears over time left till break text
 + add random tips/stretches instead of countdown in notification area
 - spanish
 - german

******************/
var debug = 0;

var bTimer, secTimer;
setDefaultOptions();
var bCount = options("breakInterval");
var mCount = options("microInterval");
var smCount = smallestCount();
var minimized = 0;
if(debug) 
{	
	var oneSec = 100; //1000 ms
	var secTime = 20 * oneSec; //in ms (60000)
}
else
{
	var oneSec = 1000; //1000 ms
	var secTime = 60 * oneSec; //in ms (60000)
}
var secBar = 100; // # of ticks in bar
var cursor = framework.system.cursor.position;
var idleCycles = 0; // in min
var newItem = new ContentItem();
//set max items
pluginHelper.max_content_items = 1;  

var tips=new Array(10)
     tips[0]= tiprest1;
     tips[1]= tiprest2;
     tips[2]= tiprest3;
     tips[3]= tiprest4;
     tips[4]= tiprest5;
     tips[5]= tiprest6;
     tips[6]= tiprest7;
     tips[7]= tiprest8;
     tips[8]= tiprest9;
     tips[9]= tiprest10;

function onUnload()
{
	stop();
}

function viewOnOpen()
{
	setLabels();
	bTimer = setInterval( "updateCount()", secTime );
	updateCountText();
	bCount--; //first timer fire (in 1 sec) will display decremented value
	mCount--;
	//sizeBar();
}

function updateCount()
{
	updateCountText();
	smCount = smallestCount();
	if(minimized) dispInCaption();
	if(bCount <= 0)
	{
		bCount = options("breakInterval");  // needs to be above the showAlert() since a break can be declined
		var title = RBreak;
		var desc  = takeRBreak;
		showAlert(title, desc, options("breakDuration"));
		mCount = options("microInterval");  // reset micro time, so it doesnt happen right after a long break
		updateCountText();
	}
	if(mCount <= 0)
	{
		var title = MBreak;
		var desc  = takeMBreak;
		showAlert(title, desc, options("microDuration"));
		mCount = options("microInterval");
		if(mCount >= bCount)
		{
			mCount = mCount + bCount; //resume micro breaks after full break
		}
		updateCountText();
	}
	if(!options("useTimeout") || userActive() || debug) // only decrement if the user is active or timeout not used
	{
		bCount--;
		mCount--;
	}
}

function updateCountText()
{
	bcount.innerText = bCount + " " + minText;
	mcount.innerText = mCount + " " + minText;
}

function userActive()
{
	if((cursor.x == framework.system.cursor.position.x) && (cursor.y == framework.system.cursor.position.y)) // mouse idle
	{
		if(idleCycles < options("idleMin"))
		{
			idleCycles++;
			return 1;
		}
		else return 0;
	}
	else // mouse moved
	{
		cursor = framework.system.cursor.position;
		idleCycles = 0;
		return 1;
	}
}

function setDefaultOptions()
{
	options.defaultValue("breakInterval") = 35; //35 min
	options.defaultValue("microInterval") = 10; //10 min
	options.defaultValue("breakDuration") = 240;//sec
	options.defaultValue("microDuration") = 30; //sec
	options.defaultValue("idleMin") = 3; //sec
	options.defaultValue("useTimeout") = 1; //true.
	options.defaultValue("allowPostpone") = 1; //true
	options.defaultValue("postponeTime") = 2; //min
}

function displayOptions()
{
	microtitlelbl.innerText = microtitletxt;
	resttitlelbl.innerText = resttitletxt;
	microdurationlbl.innerText = durationtxt;
	restdurationlbl.innerText = durationtxt;
	microtimelbl.innerText = breaktimetxt;
	resttimelbl.innerText = breaktimetxt;
	dontcountlbl.innerText = dontcounttxt;
	allowpostponelbl.innerText = allowpostponetxt;
	mintxt1.innerText = minText;
	mintxt2.innerText = minText;
	mintxt3.innerText = minText;
	sectxt1.innerText = secText;
	sectxt2.innerText = secText;


	bTime.value = options("breakInterval");
	mTime.value = options("microInterval");	
	bDuration.value = options("breakDuration");
	mDuration.value = options("microDuration");
	usetimeout.value = options("useTimeout");
	allowpostpone.value = options("allowPostpone");
	postponetime.value = options("postponeTime");
}

function updateOptions()
{
	options("breakInterval") = parseInt(bTime.value);
	options("microInterval") = parseInt(mTime.value);
	options("breakDuration") = parseInt(bDuration.value);
	options("microDuration") = parseInt(mDuration.value);
	options("useTimeout")    = usetimeout.value;
	options("allowPostpone") = allowpostpone.value;
	options("postponeTime") = parseInt(postponetime.value);
}

function showAlert(title, desc, time)
{
	clearInterval(bTimer);
	if(time == options("microDuration")) alert(title); //microbreak
	else if(options("allowPostpone"))
	{
		if(!confirm(willTakeBreak + " " + options("postponeTime") + " " + minText + ")")) //postpone the rest break
		{
			bCount = options("postponeTime"); //postpone
			mCount += options("postponeTime"); //push back micro too
			updateCountText();
			bTimer = setInterval( "updateCount()", secTime );
			return;
		}
		//else take the rest break
	}
	else
	{
		alert(title);
	}

	configureBar(title, desc, time);

	if(!debug) newItem.heading = title;
	if(!debug) newItem.snippet = desc;
	//newItem.notifier_image = "full.gif";
	if(!debug) cnArea.addContentItem(newItem, gddItemDisplayAsNotification);
	//cnArea.removeContentItem(newItem);
	if(!debug) cnArea.removeAllContentItems();
}

function configureBar(title, desc, time)
{
	progbar.enabled = 1;
	progbar.visible = 1;
	breakcount.visible = 1;
	breakcount.innerText = title;

	mnowbutton.visible = 0;
	rnowbutton.visible = 0;

	secBar = time;
	progbar.max = time;
	progbar.value = time;
	secTimer = setInterval("updateBar()", oneSec)
}

function updateBar()
{
	if(secBar <= 0) 
	{
		stopBar();
		return;
	}
	else secBar--;
	if(minimized) dispInCaption();
	progbar.value = secBar;

//update the notification window
	if(secBar%(options("microDuration")-1) == 0)
	{
		newItem.snippet = randNotification(secBar);
		if(debug) alert(newItem.snippet);
		if(!debug) cnArea.addContentItem(newItem, gddItemDisplayAsNotification);
		if(!debug) cnArea.removeAllContentItems();
	}
}

function stopBar()
{
	clearInterval(secTimer);
	bTimer = setInterval( "updateCount()", secTime );
	progbar.enabled = 0;
	progbar.visible = 0;
	breakcount.visible = 0;

	mnowbutton.visible = 1;
	rnowbutton.visible = 1;

}

function randNotification(timeLeft)
{
	if(timeLeft == 0) return backToWorkText;
	else
	{
		var ranNum= Math.floor(Math.random()*tips.length);
		return tips[ranNum];		
	}
}

function dispInCaption()
{
	if(smCount == 0)
	{
		if(secBar == 0) view.caption = backToWorkText;
		else view.caption = breakText + " " + secBar;
	}
	else view.caption = smCount + " " + minText;
	minimized = 1;
}

function dispFull()
{
	view.caption = GADGET_NAME;
	minimized = 0;
}

function smallestCount()
{
	if(bCount < mCount) return bCount;
	else return mCount;
}
function stop()
{
	clearInterval(bTimer);
	clearInterval(secTimer);
}

function sizeBar()
{
	progbar.width = view.width;
	progbar.height = view.height;
}

function toggleAllowPostpone()
{
	if(allowpostpone.value) postponetime.enabled = 1;
	else postponetime.enabled = 0;

}

function mouseOverNow(button, on)
{
	if(on)
	{
		if(button == 1) rnowbuttontext.visible = 1;
		else if(button == 2) mnowbuttontext.visible = 1;
	}
	else
	{
		if(button == 1) rnowbuttontext.visible = 0;
		else if(button == 2) mnowbuttontext.visible = 0;		
	}
}

function earlyBreak(type)
{
	clearInterval(bTimer);
	if(type == 1) mCount = 0;
	else bCount = 0;
	updateCount();
}

function setLabels()
{
	nextmicrobreak.innerText = nextmicrobreakin;
	nextfullbreak.innerText = nextfullbreakin;
	rnowbuttontext.innerText =  takeitnow;
	mnowbuttontext.innerText = takeitnow;
}